 

/*
 * This class will be used to read in names and grades and store them as students
 * @author Jeff Borland
 * @date 12-21-09
 */
import java.io.*;
import java.util.Scanner;
public class GradeBook
{

    Student[] studentList=new Student[30];

    public GradeBook() 
    {        

        // Read the name and grades from the file
        initializeFiles(); //get the scanner ready to read files
        int i=0;
        //while there is another line, read it and create a student
        while (readNextName())
        {
            studentList[i]=new Student (getFirstName(), getLastName());
            i++;
        }
        //while there is another line, read it and create a student
        while (readNextGrade())
        {
            Student foundStudent=findStudent(getGradeName());
            if (foundStudent!=null)
                foundStudent.addGrade(getGrade());

        } 

    }      

    public void printEveryStudent()
    {
        for (int i=0; i<studentList.length; i++)
        {
            studentList[i].printStudent();
        }
    }

    public int maxTest ()
    {
        int maxTests=0;
        for (int i=0; i<studentList.length; i++)
        {
            if (maxTests<studentList[i].numOfTests)
            {
                maxTests=studentList[i].numOfTests;

            }

        }
        return maxTests;
    }

    public double findClassAverage()
    {
        double total=0;
        for (int i=0; i<studentList.length; i++)
        {
            total=total+studentList[i].findAvg();
        }
        return total/studentList.length;
    }


    public int numOfBStudents()
    {
        int bStudents=0;
        for (int i=0; i<studentList.length; i++)
        {
            if (studentList[i].dropLowestAvg()>=85 && 
            studentList[i].dropLowestAvg() <= 92)
            {
                bStudents++;
            }
        }
        return bStudents;
    }


    

    /****************************************************************************************
     * The methods and variable below are to deal with reading from the files
     * You do not need to alter them
     */    

    //The two files below are going to be used to read the files names.txt and grades.txt
    Scanner names;
    Scanner grades;        
    //The four variables below will temporarily store the values read from the file
    String theGradeLine;
    String theNameLine;
    /**
     * This needs to be called in order to read from the lists.
     */
    public void initializeFiles ()
    {
        try
        {
            //just like when we scanned from System.in, this time we read from a file
            names=new Scanner(new File("names.txt"));
            grades=new Scanner(new File("grades.txt"));
        }
        catch (IOException e){}    
    }    

    /**
     * Finds the next first name in the list names.txt.  You need to call initializeFiles() first.
     * @return the next first name in the list
     */
    public boolean readNextName()
    {
        if (names.hasNext())
        {           
            theNameLine=names.nextLine(); //This reads in the next player line         
            return true;
        }    
        else return false;

    }

    public String getFirstName()
    {
        String fName=theNameLine.substring(theNameLine.indexOf(',')+1);
        return fName;
    }

    /**
     * This returns the students last name that corresponded with findFirstName()
     */
    public String getLastName()
    {
        String lName=theNameLine.substring(0,theNameLine.indexOf(','));
        return lName;
    }

    /**
     * Finds the next last name in the list grades.txt.  You need to call initializeFiles() first.
     * @return the next last name in the list grades.txt or 0 if there are not any
     */
    public boolean readNextGrade()
    {
        if (grades.hasNext())
        {
            theGradeLine=grades.nextLine(); //This reads in the next player line   
            return true;
        }    
        else return false;
    }

    public String getGradeName()
    {

        String gradeName=theGradeLine.substring(0,theGradeLine.indexOf(','));

        return gradeName;
    }

    /**
     * Finds the corresponding grade to the last name in the list grades.txt. 
     * @return the corresponding grade to findGradeName()
     */    
    public int getGrade()
    {
        String theGrade=theGradeLine.substring(theGradeLine.indexOf(',')+1);
        return Integer.parseInt(theGrade);
    }    

    public Student findStudent (String lastName)
    {
        for (int i=0; i<studentList.length; i++)
            if (studentList[i].lName.equals(lastName))
                return studentList[i];
        return null;             
    }
}